<?php

##
## This script adds watched pages markup.
## Any markup '[[notify:WikiWord]]' gets converted into
## a list of pages that are appended to the $RecentChanges array.
## This allows authors to keep a personal RecentChanges page.
##
## The markup variant '[[notify:{{free link}}]]' is also supported.
##
## Copyright 2003 John Rankin (john.rankin@affinity.co.nz)
##

$NotifyGroup = "Topics";
$title = FmtPageName('$Title',$pagename);
if (preg_match("/^$WikiWordPattern\$/",$title)) {
    $WatchingFor = '$Group.$Title';
} else {
    $WatchingFor = '$Group.{{$Titlespaced}}';
}
$WatcherPattern = "($WikiWordPattern)|($FreeLinkPattern}})";

## single notifier

if ($action=='post' && 
  preg_match_all("/\\[\\[notify:($WatcherPattern)\\]\\]/",$text,$notifies)) {
    foreach($notifies[1] as $n) {
        $i = "$NotifyGroup." . Wikify($n);
        $RecentChanges[$i] = "$WatchingFor";
    }
}
$DoubleBrackets["/\\[\\[notify:($WatcherPattern)\\]\\]/e"] = 'Notify("$1");';

## notifier list

if ($action=='post' && 
  preg_match_all("/=notify((\\s+($WatcherPattern))+)/",$text,$match)) {
    $notifies = preg_split('/\\s+/',ltrim(join(' ',$match[1])));
    foreach($notifies as $n) {
        $i = "$NotifyGroup." . Wikify($n);
        $RecentChanges[$i] = "$WatchingFor";
    }
}
$DoubleBrackets["/^=notify((\s+($WatcherPattern))+)/e"] 
  = 'NotifyList("$1");';

function NotifyList($words) {
  global $NotifyGroup,$WatcherPattern;
  $watchers = "[-<b>$NotifyGroup/$NotifyGroup:</b> ";
  $watchlist = preg_replace("/\s+/", " - ", ltrim($words));
  $watchers .=  
    preg_replace("/($WatcherPattern)/e", 'Notify("$1")' ,$watchlist) . "-]";
  return $watchers;
}

function Notify($word) {
  global $NotifyGroup;
  $watcher = Wikify($word);
  return "&lt;|$NotifyGroup/$watcher|&gt;";
}

function Wikify($word) {
  global $SpaceReplace;
  $linktext = preg_replace("/{{(.*)}}/","$1",$word);
  return preg_replace("/\s+/",$SpaceReplace,ucwords($linktext));
}

?>